// Written by TeTeT for Unsung

// FAC duty with a OV-10 Bronco

// mark targets with WP and call in the heavy weight bombers

(vehicle player) addEventHandler ["Fired", {
	params ["_unit", "_weapon", "_muzzle", "_mode", "_ammo", "_magazine", "_projectile", "_gunner"];
	if (_ammo isEqualTo "uns_Hydra_WP") then {
		[_projectile] spawn {
			params ["_projectile"];
			_lastPos = getPos _projectile;
			waitUntil { if (!(getPos _projectile isEqualTo [0,0,0])) then {
							_lastPos = getPos _projectile;
						}; 
						!(alive _projectile) };
			ttt_strikePos = _lastPos;
		};
	};
}];

[] spawn {
	while {alive player} do {
		waitUntil {!isNil "ttt_strikePos"};
		systemChat "Call in bomb strike?";
		// cooldown
		[ttt_strikePos] call ttt_fnc_strike;
		sleep 1;
		missionNamespace setVariable ["ttt_strikePos", nil];
	};
};

ttt_fnc_strike = {
	params ["_ttt_strikePos"];
	// systemChat str _ttt_strikePos;
	_caller = player;
	_caller sideChat "Calling Plane CAS";
	_caller sideChat "Target marked with smoke, confirm visual";

	// Source: http://home.earthlink.net/~aircommando1/ACTERMS.htm
	private _callsign = selectRandom ["Bonnet", "Bulldog", "Dragon", "Firefly", "Hornet", "Litterbug", "Loudmouth", "Mustang",
									  "Red Dog", "Tiger", "Zorro"];

	private _logic = "Logic" createVehicleLocal _ttt_strikePos;
	_logic setDir (random 360);
	private _veh = selectRandom [  
		"uns_A1J_navy_BMB", "uns_A1J_navy_CBU", "uns_A1J_navy_CAS", "uns_A1J_navy_HCAS",
		"uns_A4B_skyhawk_BMB", "uns_A4B_skyhawk_CBU", "uns_A4B_skyhawk_CAS", "uns_A4B_skyhawk_HCAS",
		"uns_A4E_skyhawk_BMB", "uns_A4E_skyhawk_CBU", "uns_A4E_skyhawk_CAS", "uns_A4E_skyhawk_HCAS",
		"uns_A6_Intruder_BMB", "uns_A6_Intruder_CBU", "uns_A6_Intruder_CAS", "uns_A6_Intruder_HCAS",
		"uns_A7N_BMB", "uns_A7N_CBU", "uns_A7N_CAS",
		"uns_F4J_BMB", "uns_F4J_CBU", "uns_F4J_CAS",
		"uns_A1J_BMB", "uns_A1J_CBU", "uns_A1J_CAS", "uns_A1J_HCAS",
		"uns_A7_BMB",  "uns_A7_CBU", "uns_A7_CAS",
		"uns_f100b_BMB", "uns_f100b_CBU", "uns_f100b_CAS", "uns_f100b_HCAS",
		"uns_f105D_BMB", "uns_f105D_CBU", "uns_f105D_CAS", "uns_f105D_HCAS",
		"UNS_F111_BMB", "UNS_F111_CBU", "UNS_F111_CAS", "UNS_F111_HCAS",
		"uns_F4E_BMB", "uns_F4E_CBU", "uns_F4E_CAS",
		"uns_A4E_skyhawk_USMC_BMB", "uns_A4E_skyhawk_USMC_CBU", "uns_A4E_skyhawk_USMC_CAS", "uns_A4E_skyhawk_USMC_HCAS",
		"uns_A6_Intruder_USMC_BMB", "uns_A6_Intruder_USMC_CBU", "uns_A6_Intruder_USMC_CAS", "uns_A6_Intruder_USMC_HCAS",
		"uns_F4B_BMB", "uns_F4B_CBU", "uns_F4B_CAS"
	];
	_logic setVariable ["vehicle", _veh];
	// 0 is gun run only, removed here
	// 1 = rockets
	// 2 = rockets + gun
	// 3 = bombs
	private _attacks = [1, 2, 3];
	// no rockets most often on _BMB layout
	if (_veh find "_BMB" > -1) then {
		_attacks = [3];
	};
	_logic setVariable ["type", selectRandom _attacks];
	_logic setVariable ["smoke", "Willy Pete"];
	_logic setVariable ["callsign", _callsign];
	_logic setVariable ["caller", _caller];

	[_logic, nil, true] spawn uns_mbox_fnc_moduleCAS;

	_caller;
};


// Targets and ground spotters

// randomized CAS mission for Unsung planes

ttt_cas_spotters = [];

ttt_cas_fnc_spawnTrucks = {
	params ["_pos"];
	private _grp = [ _pos, EAST, configfile >> "CfgGroups" >> "East" >> "UNSUNG_E_NVA" >> "uns_nvapatrolvehicles" >> "UNS_NVA_Convoy1" ] call BIS_fnc_spawnGroup;
	private _spotters = [ _pos getPos [300, random 360], WEST, configfile >> "CfgGroups" >> "West" >> "UNSUNG_W_US" >> "sogInfantry" >> "sog_rtone" ] call BIS_fnc_spawnGroup;
	ttt_cas_spotters pushBack  [_spotters, _grp];
	_grp;
};

ttt_cas_fnc_spawnTanks = {
	params ["_pos"];
	private _grp = [ _pos, EAST, configfile >> "CfgGroups" >> "East" >> "UNSUNG_E_NVA" >> "uns_nvatrackedvehicles" >> "UNSNVAT55Element" ] call BIS_fnc_spawnGroup;
	private _spotters = [ _pos getPos [500, random 360], WEST, configfile >> "CfgGroups" >> "West" >> "UNSUNG_W_US" >> "sogInfantry" >> "sog_rtone" ] call BIS_fnc_spawnGroup;
	ttt_cas_spotters pushBack  [_spotters, _grp];
	_grp;
};

ttt_cas_fnc_spawnInf = {
	params ["_pos"];
	private _grp = [ _pos, EAST, configfile >> "CfgGroups" >> "East" >> "UNSUNG_E_NVA" >> "NVA68Infantry" >> "NVA_68riflesquadone" ] call BIS_fnc_spawnGroup;
	private _spotters = [ _pos getPos [400, random 360], WEST, configfile >> "CfgGroups" >> "West" >> "UNSUNG_W_US" >> "sogInfantry" >> "sog_rtone" ] call BIS_fnc_spawnGroup;
	ttt_cas_spotters pushBack [_spotters, _grp];
	_grp;
};

ttt_cas_fnc_marker = {
	params ["_grp", "_type"];

	private _ldr = leader _grp;
	private _marker = createMarker [str _grp, getPos _ldr];
	_marker setMarkerText (str _marker);
	_marker setMarkerColor "ColorRed";
	switch (_type) do {
		case "trucks": { _marker setMarkerType "o_support"; };
		case "tanks": { _marker setMarkerType "o_armor"; };
		case "inf": { _marker setMarkerType "o_inf"; };
	};
	
	while {alive _ldr} do {
		_marker setMarkerPos (getPos _ldr);
		sleep 1;
	};

	_marker setMarkerColor "ColorBlack";

	_marker;
};

ttt_cas_fnc_initTargets = {
	params [["_zones", []]];

	{
		sleep random 5;
		private _zone = _x;
		private _spawnDist = _zone getVariable ["dist", 2000];
		private _pos = [_zone, 1000, _spawnDist, 100, 0, 0.25, 0, [], getPos _zone] call BIS_fnc_findSafePos;
		_pos set [2, 0];
		private _targetType = selectRandom ["tanks", "inf", "trucks"];
		switch (_targetType) do {
			case "trucks" : {
				control sideChat "Trucks have been located, check map";
				private _grp = [_pos] call ttt_cas_fnc_spawnTrucks; 
				_grp setGroupId [str _forEachIndex];
				[_grp, "trucks"] spawn ttt_cas_fnc_marker;
			};
			case "tanks" : { 
				control sideChat "Several tanks have been spotted, check map";
				private _grp = [_pos] call ttt_cas_fnc_spawnTanks; 
				_grp setGroupId [str _forEachIndex];
				[_grp, "tanks"] spawn ttt_cas_fnc_marker;
			};
			case "inf" : { 
				control sideChat "An infantry squad is out in the open, check map";
				private _grp = [_pos] call ttt_cas_fnc_spawnInf; 
				_grp setGroupId [str _forEachIndex];
				[_grp, "inf"] spawn ttt_cas_fnc_marker;
			};
		};

	} forEach _zones;
};

[] spawn {
	private _zones = [zoneNW, zoneNE, zoneSW, zoneSE];
	sleep 1;
	[_zones] call ttt_cas_fnc_initTargets;
};

[] spawn {
	// time for initialization and takeoff
	sleep 10; 
	while {alive player} do {
		{
			private _spotters = _x # 0;
			if (alive player and alive leader _spotters and player distance (leader _spotters) < 3000 and
				!((leader _spotters) getVariable ["ttt_cas_smoke", false])) then {
				private _smokePos = getPos (leader _spotters);
				private _smokeType = selectRandom [
									["SmokeShell", "White"],
									["SmokeShellRed", "Red"],
									["SmokeShellGreen", "Green"],
									["SmokeShellYellow", "Yellow"],
									["SmokeShellPurple", "Purple"],
									["SmokeShellBlue", "Blue"],
									["SmokeShellOrange", "Orange"]
									];
				private _smoke = createVehicle [_smokeType # 0, _smokePos, [], 0, "NONE"];
				_smoke setPos [_smokePos select 0, _smokePos select 1, 5];
				_smoke setDamage 1;
				(leader _spotters) setVariable ["ttt_cas_smoke", true];
				(leader _spotters) sideChat format ["Marking our position with %1 smoke", _smokeType # 1];
				(leader _spotters) sideChat format ["Target at %1 in %2 from our smoke",
					floor((leader _spotters) getDir (leader (_x # 1))), floor((leader _spotters) distance (leader (_x # 1)))
				];
				[leader _spotters] spawn {
					sleep 60;
					(_this # 0) setVariable ["ttt_cas_smoke", false];
				};
			};
			sleep 1;
		} forEach ttt_cas_spotters;
	};
}